//GF: 12mar09 as suggested by JC but could not be tested on
//westkill because of compilation issues.

//********************************************************
// Syzygy is licensed under the BSD license v2
// see the file SZG_CREDITS for details
//********************************************************

#include "arPrecompiled.h"

#include "arGlut.h"
#include "arGraphicsHeader.h"
#include "arInputSimulator.h"
#include "arLogStream.h"
#include "arSTLalgo.h"
#include "arSZGClient.h"
//GF1. arDefaultInputSimulator -> wuss0

// Very uninteresting arInputSimulator subclass that just behaves
// exactly like the base class.
class wuss0: public arInputSimulator {
 public:
  wuss0();
  virtual ~wuss0();

  virtual bool configure( arSZGClient& SZGClient );

  virtual void draw();
  virtual void drawWithComposition();
  virtual void advance();

  // Mouse/keyboard input.
  virtual void keyboard(unsigned char key, int state, int x, int y);
  virtual void mouseButton(int button, int state, int x, int y);
  virtual void mousePosition(int x, int y);

  virtual bool setMouseButtons( vector<unsigned>& mouseButtons );
  //GF globals
  int Ndown, Edown, Wdown, Sdown;
  //GF where do these get initialized?
};

// The plugin exposes only these two functions.
// The plugin interface (in arInputSimulatorFactory.cpp) calls baseType()
// to verify that this shared library is an input simulator plugin.
// It then calls factory() to instantiate an object.
// Further calls are made to that instance's methods.
#undef SZG_IMPORT_LIBRARY
#undef SZG_DO_NOT_EXPORT
#include "arCallingConventions.h"
extern "C" {
  SZG_CALL void baseType(char* buffer, int size)
    { ar_stringToBuffer("arInputSimulator", buffer, size); }
  SZG_CALL void* factory()
    { return (void*) new wuss0(); }
}


wuss0::wuss0() : arInputSimulator(){}
//GF in n-wuss.cpp I had 
// " : Ndown(0), Edown(0), etc { "
// does this go here too?

wuss0::~wuss0() {
}

bool wuss0::configure( arSZGClient& SZGClient ) {
  return arInputSimulator::configure( SZGClient );
}

// Possibly an overlay on a standalone app's window.
void wuss0::draw() {
  arInputSimulator::draw();
}

// Overlay the display.  Not const because pre,postComposition can't be.
void wuss0::drawWithComposition() {
  arInputSimulator::drawWithComposition();
}

// Called occasionally to post the current state of the simulated
// device to newly connected arInputNodes.
void wuss0::advance() {
  arInputSimulator::advance();
  //GF 3. affect the head matrix for now, should become the navmat?
  if(_interfaceState == AR_SIM_HEAD_ROTATE){
      float dthrust = .01;
      static float thrust = 0.0 ;
      float droll = .01;
      static float roll = 0.0;
      if(Ndown){Ndown=0; thrust += dthrust;}
      if(Edown){Edown=0; roll += droll;}
      if(Wdown){Wdown=0; roll -= droll;}
      if(Sdown){Sdown=0; thrust -= dthrust;}
      arVector3 thrustvector(0,0,thrust);
printf("thrust-roll %f %f\n", thrust, roll);
      _head.rotate(0,0,roll);
      _head.translate(thrustvector);
     }

}

// Process keyboard events.
void wuss0::keyboard( unsigned char key, int state, int x, int y ) {
  arInputSimulator::keyboard( key, state, x, y );
  //GF 2.  here N=j, E=l, W=h, S=k
  switch(key){
    case 'h': Wdown = 1; break;
    case 'j': Ndown = 1; break;
    case 'k': Sdown = 1; break;
    case 'l': Edown = 1; break;
}

// Process mouse button events.
void wuss0::mouseButton(int button, int state, int x, int y) {
  arInputSimulator::mouseButton( button, state, x, y );
}

// Mouse moved.
void wuss0::mousePosition(int x, int y) {
  arInputSimulator::mousePosition( x, y );
}

bool wuss0::setMouseButtons( vector<unsigned>& mouseButtons ) {
  return arInputSimulator::setMouseButtons( mouseButtons );
}


